config/routes.rb
Rails.application.routes.draw do
  resources :movies
  root 'movies#index'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/movie.rb
class Movie < ApplicationRecord
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
end

app/controllers/movies_controller.rb
class MoviesController < ApplicationController
  before_action :set_movie, only: [:show, :edit, :update, :destroy]

  # GET /movies
  # GET /movies.json
  def index
    @movies = Movie.all
  end

  # GET /movies/1
  # GET /movies/1.json
  def show
  end

  # GET /movies/new
  def new
    @movie = Movie.new
  end

  # GET /movies/1/edit
  def edit
  end

  # POST /movies
  # POST /movies.json
  def create
    @movie = Movie.new(movie_params)

    respond_to do |format|
      if @movie.save
        format.html { redirect_to @movie, notice: 'Movie was successfully created.' }
        format.json { render :show, status: :created, location: @movie }
      else
        format.html { render :new }
        format.json { render json: @movie.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /movies/1
  # PATCH/PUT /movies/1.json
  def update
    respond_to do |format|
      if @movie.update(movie_params)
        format.html { redirect_to @movie, notice: 'Movie was successfully updated.' }
        format.json { render :show, status: :ok, location: @movie }
      else
        format.html { render :edit }
        format.json { render json: @movie.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /movies/1
  # DELETE /movies/1.json
  def destroy
    @movie.destroy
    respond_to do |format|
      format.html { redirect_to movies_url, notice: 'Movie was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_movie
      @movie = Movie.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def movie_params
      params.require(:movie).permit(:title, :release_year, :price, :description, :imdb_id, :poster_url)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/movies_helper.rb
module MoviesHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />

    <title><%= content_for?(:title) ? yield(:title) : "foundation-rails" %></title>

    <%= stylesheet_link_tag    "application" %>
    <%= javascript_include_tag "vendor/modernizr" %>
    <%= csrf_meta_tags %>
  </head>

  <body>

    <%= yield %>
    <%= javascript_include_tag "application" %>
  </body>
</html>

app/views/movies/_form.html.erb
<%= form_with(model: movie, local: true) do |form| %>
  <% if movie.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(movie.errors.count, "error") %> prohibited this movie from being saved:</h2>

      <ul>
      <% movie.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title, id: :movie_title %>
  </div>

  <div class="field">
    <%= form.label :release_year %>
    <%= form.number_field :release_year, id: :movie_release_year %>
  </div>

  <div class="field">
    <%= form.label :price %>
    <%= form.text_field :price, id: :movie_price %>
  </div>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_area :description, id: :movie_description %>
  </div>

  <div class="field">
    <%= form.label :imdb_id %>
    <%= form.text_field :imdb_id, id: :movie_imdb_id %>
  </div>

  <div class="field">
    <%= form.label :poster_url %>
    <%= form.text_field :poster_url, id: :movie_poster_url %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/movies/edit.html.erb
<h1>Editing Movie</h1>

<%= render 'form', movie: @movie %>

<%= link_to 'Show', @movie %> |
<%= link_to 'Back', movies_path %>

app/views/movies/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Movies</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Release year</th>
      <th>Price</th>
      <th>Description</th>
      <th>Imdb</th>
      <th>Poster url</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @movies.each do |movie| %>
      <tr>
        <td><%= movie.title %></td>
        <td><%= movie.release_year %></td>
        <td><%= movie.price %></td>
        <td><%= movie.description %></td>
        <td><%= movie.imdb_id %></td>
        <td><%= movie.poster_url %></td>
        <td><%= link_to 'Show', movie %></td>
        <td><%= link_to 'Edit', edit_movie_path(movie) %></td>
        <td><%= link_to 'Destroy', movie, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Movie', new_movie_path %>

app/views/movies/new.html.erb
<h1>New Movie</h1>

<%= render 'form', movie: @movie %>

<%= link_to 'Back', movies_path %>

app/views/movies/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @movie.title %>
</p>

<p>
  <strong>Release year:</strong>
  <%= @movie.release_year %>
</p>

<p>
  <strong>Price:</strong>
  <%= @movie.price %>
</p>

<p>
  <strong>Description:</strong>
  <%= @movie.description %>
</p>

<p>
  <strong>Imdb:</strong>
  <%= @movie.imdb_id %>
</p>

<p>
  <strong>Poster url:</strong>
  <%= @movie.poster_url %>
</p>

<%= link_to 'Edit', edit_movie_path(@movie) %> |
<%= link_to 'Back', movies_path %>